/*
 * This is the code for an ATTinyX313 double-7-segment-display.
 * It only uses the second decimal point, just because I only need this one and the Tiny is short by one pin.
 * (Use the RESET pin, if you're feeling adventurous.)
 * The wiring is convienient for my breadboard setup. The fexibility of software! 
 */
 
#include <Wire.h>

//physical connections to the displays. {A, B, C, D, E, F, G}
int DISPLAY_1[] = {6,4,8,10,9,5,7};
int DISPLAY_2[] = {1,3,13,11,12,2,0};
int DEC_POINT_2 = 15;

//Output-states for displaying the characters. (Configured for common-anode displays. invert when using c-k)
bool NUMBERS[][10] = {{0,0,0,0,0,0,1}, //0
                      {1,0,0,1,1,1,1}, //1 The first version was {1,1,1,1,0,0,1}, but that was just a very weird '1'.
                      {0,0,1,0,0,1,0}, //2
                      {0,0,0,0,1,1,0}, //3
                      {1,0,0,1,1,0,0}, //4
                      {0,1,0,0,1,0,0}, //5
                      {0,1,0,0,0,0,0}, //6
                      {0,0,0,1,1,1,1}, //7
                      {0,0,0,0,0,0,0}, //8
                      {0,0,0,0,1,0,0}}; //9

void setup() {

  Wire.begin(8);                // join i2c bus with address #8
  Wire.onReceive(receiveEvent); // register event (Just copied from some example.)

  //set all the needed pins to output mode.
  for(int i = 0; i < 7; i++){
    
    pinMode(DISPLAY_1[i], OUTPUT);
    pinMode(DISPLAY_2[i], OUTPUT);
  
  }

  pinMode(DEC_POINT_2, OUTPUT);
  digitalWrite(DEC_POINT_2, LOW);


}

void loop() {

  //function to test the displays an wiring (just looping through the characters defined above)
 /* for(int i = 0; i < 10; i++){

      for(int j = 0; j < 7; j++){
    
        digitalWrite(DISPLAY_1[j], NUMBERS[i][j]);
        digitalWrite(DISPLAY_2[j], NUMBERS[i][j]);

      }

      delay(1000);
  
    }*/
  
}

//Here happens all the magic
void receiveEvent() {
  
  //first, all the received data will be stored in VALUE[]
  digitalWrite(DEC_POINT_2, HIGH); //This is just used to get a little visual feedback on the I²C traffic. 
  int position = 0;
  char VALUE[3];
 
  while (Wire.available()) {
    
    VALUE[position] = Wire.read();
    position++;
    
  }
  
  digitalWrite(DEC_POINT_2, LOW);
  
  //The rest is just comapring and switching. Nothing special and pretty bulky.
  switch (VALUE[0]){//The first received char is for the first part of the display

    case '0'://So, if a '0' is received, display a '0'.

      for(int j = 0; j < 7; j++){
    
        digitalWrite(DISPLAY_1[j], NUMBERS[0][j]);
        //digitalWrite(DISPLAY_2[j], NUMBERS[VALUE[1]][j]); //for future purposes?

     }
     break;
     case '1':

      for(int j = 0; j < 7; j++){
    
        digitalWrite(DISPLAY_1[j], NUMBERS[1][j]);
        //digitalWrite(DISPLAY_2[j], NUMBERS[VALUE[1]][j]);

     }
     break;
     case '2':

      for(int j = 0; j < 7; j++){
    
        digitalWrite(DISPLAY_1[j], NUMBERS[2][j]);
        //digitalWrite(DISPLAY_2[j], NUMBERS[VALUE[1]][j]);

     }
     break;
     case '3':

      for(int j = 0; j < 7; j++){
    
        digitalWrite(DISPLAY_1[j], NUMBERS[3][j]);
        //digitalWrite(DISPLAY_2[j], NUMBERS[VALUE[1]][j]);

     }
     break;
     case '4':

      for(int j = 0; j < 7; j++){
    
        digitalWrite(DISPLAY_1[j], NUMBERS[4][j]);
        //digitalWrite(DISPLAY_2[j], NUMBERS[VALUE[1]][j]);

     }
     break;
     case '5':

      for(int j = 0; j < 7; j++){
    
        digitalWrite(DISPLAY_1[j], NUMBERS[5][j]);
        //digitalWrite(DISPLAY_2[j], NUMBERS[VALUE[1]][j]);

     }
     break;
     case '6':

      for(int j = 0; j < 7; j++){
    
        digitalWrite(DISPLAY_1[j], NUMBERS[6][j]);
        //digitalWrite(DISPLAY_2[j], NUMBERS[VALUE[1]][j]);

     }
     break;
     case '7':

      for(int j = 0; j < 7; j++){
    
        digitalWrite(DISPLAY_1[j], NUMBERS[7][j]);
        //digitalWrite(DISPLAY_2[j], NUMBERS[VALUE[1]][j]);

     }
     break;
     case '8':

      for(int j = 0; j < 7; j++){
    
        digitalWrite(DISPLAY_1[j], NUMBERS[8][j]);
        //digitalWrite(DISPLAY_2[j], NUMBERS[VALUE[1]][j]);

     }
     break;
     case '9':

      for(int j = 0; j < 7; j++){
    
        digitalWrite(DISPLAY_1[j], NUMBERS[9][j]);
        //digitalWrite(DISPLAY_2[j], NUMBERS[VALUE[1]][j]);

     }
     break;
     default:

      for(int j = 0; j < 7; j++){
    
        digitalWrite(DISPLAY_1[j], HIGH);
        //digitalWrite(DISPLAY_2[j], HIGH);

     }
     break;
    
  }
  
  switch (VALUE[1]){

    case '0':

      for(int j = 0; j < 7; j++){
    
        //digitalWrite(DISPLAY_1[j], NUMBERS[0][j]);
        digitalWrite(DISPLAY_2[j], NUMBERS[0][j]);

     }
     break;
     case '1':

      for(int j = 0; j < 7; j++){
    
        //digitalWrite(DISPLAY_1[j], NUMBERS[1][j]);
        digitalWrite(DISPLAY_2[j], NUMBERS[1][j]);

     }
     break;
     case '2':

      for(int j = 0; j < 7; j++){
    
        //digitalWrite(DISPLAY_1[j], NUMBERS[2][j]);
        digitalWrite(DISPLAY_2[j], NUMBERS[2][j]);

     }
     break;
     case '3':

      for(int j = 0; j < 7; j++){
    
        //digitalWrite(DISPLAY_1[j], NUMBERS[3][j]);
        digitalWrite(DISPLAY_2[j], NUMBERS[3][j]);

     }
     break;
     case '4':

      for(int j = 0; j < 7; j++){
    
        //digitalWrite(DISPLAY_1[j], NUMBERS[4][j]);
        digitalWrite(DISPLAY_2[j], NUMBERS[4][j]);

     }
     break;
     case '5':

      for(int j = 0; j < 7; j++){
    
        //digitalWrite(DISPLAY_1[j], NUMBERS[5][j]);
        digitalWrite(DISPLAY_2[j], NUMBERS[5][j]);

     }
     break;
     case '6':

      for(int j = 0; j < 7; j++){
    
        //digitalWrite(DISPLAY_1[j], NUMBERS[6][j]);
        digitalWrite(DISPLAY_2[j], NUMBERS[6][j]);

     }
     break;
     case '7':

      for(int j = 0; j < 7; j++){
    
        //digitalWrite(DISPLAY_1[j], NUMBERS[7][j]);
        digitalWrite(DISPLAY_2[j], NUMBERS[7][j]);

     }
     break;
     case '8':

      for(int j = 0; j < 7; j++){
    
        //digitalWrite(DISPLAY_1[j], NUMBERS[8][j]);
        digitalWrite(DISPLAY_2[j], NUMBERS[8][j]);

     }
     break;
     case '9':

      for(int j = 0; j < 7; j++){
    
        //digitalWrite(DISPLAY_1[j], NUMBERS[9][j]);
        digitalWrite(DISPLAY_2[j], NUMBERS[9][j]);

     }
     break;
     default:

      for(int j = 0; j < 7; j++){
    
        //digitalWrite(DISPLAY_1[j], NUMBERS[9][j]);
        digitalWrite(DISPLAY_2[j], HIGH);
        digitalWrite(DEC_POINT_2, HIGH);

     }
     break;
    
  }
  
}
